ListKong/Controllers/InventoryController.cs
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.IO;
using System.Linq;
using System.Threading.Tasks;
using ListKong.Models;
using ListKong.Utility;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Configuration;

namespace ListKong.Controllers
{
    [Authorize]
    public class InventoryController : Controller
    {
        #region Controller Properties
        private IConfiguration _configuration;
        private CommonHelper _objHelper;
        private SQLGateway _objDataHelper;
        public string cnnect;
        public string keyForEncrypt, encryptedToken, encryptedEmail, formFlag;

        public InventoryController(IConfiguration configuration)
        {
            this._configuration = configuration;
            this._objDataHelper = new SQLGateway(this._configuration.GetConnectionString("DefaultConnection"));
            this._objHelper = new CommonHelper(this._configuration);
            cnnect = this._configuration.GetConnectionString("DefaultConnection");
        }
        #endregion
        public IActionResult Index()
        {
            string companyName = HttpContext.Session.GetString("_CompanyName");
            string companyId = HttpContext.Session.GetString("_CompanyId");
            if (string.IsNullOrEmpty(companyName))
            {
                return RedirectToAction("Index", "Company");
            }
            try
            {
                DataTable _dtResponseP = InventoryList();
                if (this._objHelper.checkDBNullResponse(_dtResponseP))
                {
                    List<InventoryListModel> lst = new List<InventoryListModel>();
                    lst = ExtensionMethods.DataTableToList<InventoryListModel>(_dtResponseP);
                    return View(lst);
                }
            }
            catch (Exception ex)
            {
                string E = ex.Message.ToString();
                return View();
            }
            return View();
        }
        public IActionResult AddInventory()
        {
            string companyName = HttpContext.Session.GetString("_CompanyName");
            string companyId = HttpContext.Session.GetString("_CompanyId");
            if (string.IsNullOrEmpty(companyName))
            {
                return RedirectToAction("Index", "Company");
            }
            InventoryModel model = new InventoryModel();
            model.CompanyName = companyName;
            model.InvCompanyID = Convert.ToInt32(companyId);
            var userId = @User.Claims.FirstOrDefault(c => c.Type == "http://schemas.xmlsoap.org/ws/2005/05/identity/claims/nameidentifier").Value;
            var role = @User.Claims.FirstOrDefault(c => c.Type == "http://schemas.microsoft.com/ws/2008/06/identity/claims/role").Value;
            List<KeyValuePair<string, string>> parameters = new List<KeyValuePair<string, string>>();
            parameters.Add(new KeyValuePair<string, string>("@userId", userId));
            parameters.Add(new KeyValuePair<string, string>("@role", role));
            DataTable dt = _objDataHelper.ExecuteProcedure("app_Get_Company_Location_By_User_Id", parameters);
            if (dt != null && dt.Rows.Count > 0)
            {
                model.InvCompanyID = Convert.ToInt32(dt.Rows[0]["CompanyID"]);
                model.InvLocationID = Convert.ToInt32(dt.Rows[0]["LocID"]);
                model.CompanyName = Convert.ToString(dt.Rows[0]["cCompanyName"]);
                model.LocationName = Convert.ToString(dt.Rows[0]["LocName"]);
            }
            //if (role == "Admin")
            //{
                ViewData["LocationByCompany"] = LocationList();
            //}
            ViewData["Brands"] = BrandList();
            ViewData["Colors"] = ColorList();
            ViewData["InventoryConditionList"] = InventoryConditionList();


            return View(model);
        }

        [HttpPost]
        public IActionResult AddInventory(InventoryModel model)
        {
            var role = @User.Claims.FirstOrDefault(c => c.Type == "http://schemas.microsoft.com/ws/2008/06/identity/claims/role").Value;
            if (!ModelState.IsValid)
            {
               // if (role == "Admin")
               // {
                    ViewData["LocationByCompany"] = LocationList();
                //}
                ViewData["Brands"] = BrandList();
                ViewData["Colors"] = ColorList();
                ViewData["InventoryConditionList"] = InventoryConditionList();
                return View(model);
            }
            try
            {
                var userId = @User.Claims.FirstOrDefault(c => c.Type == "http://schemas.xmlsoap.org/ws/2005/05/identity/claims/nameidentifier").Value;
                List<KeyValuePair<string, string>> parameters = new List<KeyValuePair<string, string>>();
                parameters.Add(new KeyValuePair<string, string>("@userId", userId));
                parameters.Add(new KeyValuePair<string, string>("@companyId", Convert.ToString(model.InvCompanyID)));
                parameters.Add(new KeyValuePair<string, string>("@locationId", Convert.ToString(model.InvLocationID)));
                parameters.Add(new KeyValuePair<string, string>("@inventoryName", model.InvName));
                parameters.Add(new KeyValuePair<string, string>("@inventoryDesc", model.InvDesc));

                parameters.Add(new KeyValuePair<string, string>("@MainColorId", Convert.ToString(model.MainColorId)));
                if (!string.IsNullOrEmpty(model.OtherMainColor))
                    parameters.Add(new KeyValuePair<string, string>("@OtherMainColor", model.OtherMainColor));
                parameters.Add(new KeyValuePair<string, string>("@SecondColorId", Convert.ToString(model.SecondColorId)));
                if (!string.IsNullOrEmpty(model.OtherSecondaryColor))
                    parameters.Add(new KeyValuePair<string, string>("@OtherSecondaryColor", model.OtherSecondaryColor));
                parameters.Add(new KeyValuePair<string, string>("@InvBrandId", Convert.ToString(model.InvBrandId)));
                if (!string.IsNullOrEmpty(model.OtherBrand))
                    parameters.Add(new KeyValuePair<string, string>("@OtherBrand", Convert.ToString(model.OtherBrand)));

                parameters.Add(new KeyValuePair<string, string>("@InvModelName", model.InvModelName));
                parameters.Add(new KeyValuePair<string, string>("@InvModelNumber", model.InvModelNumber));
                parameters.Add(new KeyValuePair<string, string>("@InvShape", model.InvShape));
                parameters.Add(new KeyValuePair<string, string>("@ItemSeparateCustomersPurchase", Convert.ToString(model.ItemSeparateCustomersPurchase)));
                parameters.Add(new KeyValuePair<string, string>("@ItemIncludedInOnePurchase", Convert.ToString(model.ItemIncludedInOnePurchase)));
                parameters.Add(new KeyValuePair<string, string>("@Descriptor1", model.Descriptor1));
                parameters.Add(new KeyValuePair<string, string>("@Descriptor2", model.Descriptor2));
                parameters.Add(new KeyValuePair<string, string>("@Descriptor3", model.Descriptor3));
                parameters.Add(new KeyValuePair<string, string>("@Height", model.Height));
                parameters.Add(new KeyValuePair<string, string>("@Width", model.Width));
                parameters.Add(new KeyValuePair<string, string>("@Depth", model.Depth));
                parameters.Add(new KeyValuePair<string, string>("@WeightInPound", model.WeightInPound));
                parameters.Add(new KeyValuePair<string, string>("@WeightInInches", model.WeightInInches));
                parameters.Add(new KeyValuePair<string, string>("@AnyDamage", model.AnyDamage));
                parameters.Add(new KeyValuePair<string, string>("@AdditionalNotes", model.AdditionalNotes));
                parameters.Add(new KeyValuePair<string, string>("@ConditionId", Convert.ToString(model.ConditionId)));
                parameters.Add(new KeyValuePair<string, string>("@StorageLocationLsle", Convert.ToString(model.StorageLocationLsle)));
                parameters.Add(new KeyValuePair<string, string>("@StorageLocationColumn", Convert.ToString(model.StorageLocationColumn)));
                parameters.Add(new KeyValuePair<string, string>("@StorageLocationRow", Convert.ToString(model.StorageLocationRow)));
                DataTable dt = _objDataHelper.ExecuteProcedure("app_Add_New_Inventory", parameters);
                if (dt != null && dt.Rows.Count > 0)
                {
                    ViewData["SuccessMessage"] = "Inventory successfully added!";
                    model.InvID = Convert.ToInt32(dt.Rows[0]["InventoryID"]);
                }
                DataTable dtTemp = new DataTable();
                dtTemp.Columns.Add("ImageName", typeof(string));
                dtTemp.Columns.Add("ImagePath", typeof(string));
                model.InventoryImages = new List<InventoryImageModel>();
                model.InventoryImages.Add(new InventoryImageModel { InventoryImage = model.InventoryImage1 });
                if (model.InventoryImage2 != null)
                    model.InventoryImages.Add(new InventoryImageModel { InventoryImage = model.InventoryImage2 });
                if (model.InventoryImage3 != null)
                    model.InventoryImages.Add(new InventoryImageModel { InventoryImage = model.InventoryImage3 });
                if (model.InventoryImage4 != null)
                    model.InventoryImages.Add(new InventoryImageModel { InventoryImage = model.InventoryImage4 });

                if (model.InventoryImage5 != null)
                    model.InventoryImages.Add(new InventoryImageModel { InventoryImage = model.InventoryImage5 });
                if (model.InventoryImage6 != null)

ListKong/Views/Inventory/Gallery.cshtml
@model ListKong.Models.InventoryModel

@{
    ViewData["Title"] = "Gallery";
}
<script src="~/js/InventoryPage.js"></script>
<div class="container-fluid" style="min-height: 500.8px;margin:0 !important;">
    <section class="content-header">

        <ol class="breadcrumb">
            <li><a asp-controller="Inventory" asp-action="Index"><i class="fa fa-dashboard"></i><span class="icon-after-span">Manage Inventory</span></a></li>
            <li class="active">Gallery</li>
        </ol>
    </section>
    <section class="content">
        <div class="row">
            <div class="col-md-12">
                <div class="panel panel-default">
                    <div class="panel-heading">
                        <h4 class="box-title">Gallery</h4>
                    </div>
                    <form id="step3" name="formname" enctype="multipart/form-data">
                        <div class="panel-body table-responsive">
                            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
                            <input asp-for="InvLocationID" type="hidden" class="form-control" />
                            <input asp-for="InvID" type="hidden" class="form-control" />
                            <input asp-for="InvCompanyID" type="hidden" class="form-control" />

                            <div class="form-group">
                                <label asp-for="InvName" class="control-label"></label>
                                <input asp-for="InvName" class="form-control" style="width:50%" readonly />
                                <span asp-validation-for="InvName" class="text-danger"></span>
                            </div>

                            <div class="form-group">
                                <div class="row" id="invGallery">
                                    @foreach (var item in Model.InventoryImages)
                                    {

                                        <div class="col-md-4" style="margin-top:25px;">
                                            <div style="float:left">
                                                <img src="@item.FileName" alt="Inventory Image" class="myImg" width="150" height="150" />
                                            </div>
                                            @if (Model.InventoryStatus != 3)
                                            {
                                                @if (!User.IsInRole("Lister"))
                                                {
                                                    <div style="float:left">
                                                        <input type="button" class="btn btn-danger clsDeletemore" data-id="@item.ImageId" value="Delete" style="margin-left: 10px;" />
                                                    </div>
                                                }
                                            }
                                        </div>
                                    }
                                </div>
                            </div>
                            @if (Model.InventoryStatus != 3)
                            {
                                @if (!User.IsInRole("Lister"))
                                {
                                    @if (Model.InventoryImages.Count < 12)
                                    {
                                        <div id="imagesDiv">
                                            <label class="control-label"> Inventory Pics</label>
                                            <input type="hidden" id="hdnImagesCount" value="1" />

                                            <div class="form-group">

                                                <div class="row" style="margin-left:0px;">
                                                    <input type="file" required class="form-control" name="InventoryImages[1].InventoryImage" id="InventoryImages[1].InventoryImage" style="width:50%;" />

                                                    <input type="button" class="btn btn-primary clsAddGalleryImage" value="Add More" style="margin-top:5px;" />

                                                </div>
                                            </div>

                                        </div>
                                    }
                                }
                            }
                        </div>
                    </form>
                    <div class="footer-listing">
                        <a style="text-align:right" asp-controller="Inventory" asp-action="Index"><i class="os-icon os-icon-signs-11"></i><span>Back to List</span></a>
                    </div>
                </div>
            </div>
        </div>
    </section>
</div>
<!-- The Modal -->
<div id="myModal" class="modal">
    <span class="close close_button">&times;</span>
    <img class="modal-content" id="img01">
    <div id="caption"></div>
</div>

ListKong/Views/Inventory/Index.cshtml
@model IEnumerable<InventoryListModel>

@{
    ViewData["Title"] = "Index";
}
<script src="~/js/InventoryPage.js"></script>
<div class="container-fluid" style="min-height: 500.8px;margin:0 !important;">
    <section class="content-header">

        <ol class="breadcrumb">
            <li><a href="#"><i class="fa fa-dashboard"></i><span class="icon-after-span">Home</span> </a></li>
            <li class="active">Manage Inventory</li>
        </ol>
    </section>
    <section class="content">
        <div class="row">
            <div class="col-md-12">
                <div class="panel panel-default">
                    <div class="panel-heading">
                        <h4 class="box-title">Inventory Listing</h4>
                        <div class="box-tools">
                            @if (User.IsInRole("Admin") || User.IsInRole("Inventory Manager"))
                            {
                                <div class="input-group input-group-sm" style="width: 150px;text-align:right;">
                                    <a asp-controller="Inventory" asp-action="AddInventory"><i class="fa fa-plus-circle"></i><span class="icon-after-span">Add New</span></a>
                                </div>
                            }
                        </div>
                    </div>
                    <!-- /.box-header -->
                    <div class="panel-body table-responsive">
                        @if (!string.IsNullOrEmpty(Convert.ToString(TempData["ErrorMessage"])))
                        {
                            <div class="alert alert-danger">  @TempData["ErrorMessage"]</div>
                            <script>
                                $(function () {
                                    setTimeout(function () { hideTarget(); }, 5000);
                                });
                                function hideTarget() {
                                    $(".alert").hide();
                                }
                            </script>
                        }
                        @if (!string.IsNullOrEmpty(Convert.ToString(TempData["SuccessMessage"])))
                        {
                            <div class="alert alert-success">  @TempData["SuccessMessage"]</div>
                            <script>
                                $(function () {
                                    setTimeout(function () { hideTarget(); }, 5000);
                                });
                                function hideTarget() {
                                    $(".alert").hide();
                                }
                            </script>
                        }
                        <table class="table table-bordered">
                            <thead>
                                <tr>
                                    <th>
                                        @Html.DisplayNameFor(model => model.InvID)
                                    </th>
                                    <th>
                                        Picture
                                    </th>
                                    <th>
                                        @Html.DisplayNameFor(model => model.CompanyName)
                                    </th>
                                    <th>
                                        @Html.DisplayNameFor(model => model.InvName)
                                    </th>
                                    <th>
                                        @Html.DisplayNameFor(model => model.InvDesc)
                                    </th>
                                    <th>
                                        @Html.DisplayNameFor(model => model.StatusName)
                                    </th>
                                    <th>
                                        @Html.DisplayNameFor(model => model.InvCreatedDate)
                                    </th>

                                    <th></th>
                                </tr>
                            </thead>
                            <tbody>
                                @foreach (var item in Model)
                                {
                                <tr>
                                    <td>
                                        @Html.DisplayFor(modelItem => item.InvID)
                                    </td>
                                    <td>
                                        <img src="~/@item.Thumbnail" width="100" height="100" />
                                    </td>
                                    <td>
                                        @Html.DisplayFor(modelItem => item.CompanyName)
                                    </td>
                                    <td>
                                        @*@Html.DisplayFor(modelItem => item.InvName)*@
                                        @if (item.InvName.Length <= 15)
                                        {
                                            @Html.DisplayFor(modelItem => item.InvName)
                                        }
                                        else
                                        {
                                            @string.Format("{0}{1}", @item.InvName.Substring(0, 15), "...");
                                        }
                                    </td>
                                    <td>
                                        @if (item.InvDesc.Length <= 15)
                                        {
                                            @Html.DisplayFor(modelItem => item.InvDesc)
                                        }
                                        else
                                        {
                                            @string.Format("{0}{1}", @item.InvDesc.Substring(0, 15), "...");
                                        }

                                    </td>
                                    <td>
                                        @if (@item.InvStatus != 3)
                                        {
                                            <span style="color:red;">
                                                @Html.DisplayFor(modelItem => item.StatusName)
                                            </span>
                                        }
                                        else
                                        {
                                            <span style="color:green;font-weight:bold;">
                                                @Html.DisplayFor(modelItem => item.StatusName)
                                            </span>
                                        }
                                    </td>

                                    <td>
                                        @Html.DisplayFor(modelItem => item.InvCreatedDate)
                                    </td>
                                    <td>
                                        @if (@item.InvStatus != 3)
                                        {
                                            @if (!User.IsInRole("Photographer"))
                                            {
                                                <a asp-action="Edit" style="cursor:pointer;" asp-route-id="@item.InvID" class="fa fa-edit" title="Edit Inventory"></a>
                                            }
                                            <a asp-action="Gallery" style="cursor:pointer;" asp-route-id="@item.InvID" class="fa fa-image" title="Gallery"></a>
                                            @if ((User.IsInRole("Admin") || User.IsInRole("Lister")) && @item.InvStatus == 2)
                                            {

                                                <a data-id="@item.InvID" class="approveInv" style="cursor:pointer;" title="Need Approval"><i class="fa fa-check-circle"></i><span></span></a>

                                            }
                                            @if (User.IsInRole("Admin"))
                                            {
                                                <a asp-action="Delete" style="cursor:pointer;" asp-route-id="@item.InvID" onclick="return confirm('Are sure wants to delete?');" class="fa fa-trash" title="Delete Inventory"></a>
                                            }
                                        }
                                        else
                                        {
                                            <a asp-action="Gallery" style="cursor:pointer;" asp-route-id="@item.InvID" class="fa fa-image" title="Gallery"></a>
                                        }
                                    </td>
                                </tr>
                                }
                            </tbody>
                        </table>
                    </div>
                </div>
                <div>
                    @*<a asp-action="Index">Back to List</a>*@
                </div>
                <!-- /.box -->
            </div>
        </div>
    </section>
</div>